<template>
<v-dialog :value="value" @input="$emit('input')" scrollable max-width="700px">
  <v-card>
  <v-card-text>
  <v-stepper
    v-model="e1"
    alt-labels
  >
     <template>
      <v-stepper-header>
        <template v-for="(n,index) in steps">
          <v-stepper-step
            :key="`${index+1}-step`"
            :complete="e1 > index+1"
            :step="index+1"
          >
          <span class="text-center">{{ n }}</span>
          </v-stepper-step>
          <v-divider
            v-if="index+1 !== steps.length"
            :key="index+1"
          ></v-divider>
        </template>
      </v-stepper-header>
      <v-stepper-items>
        <v-stepper-content
          v-for="(n,index) in steps"
          :key="`${index+1}-content`"
          :step="index+1"
        >
         <div class="content-header" v-if="index > 0">
            <v-btn x-small @click="goBack(index+1)" text class="btnback">
              <i class="fas fa-chevron-left"></i> Regresar
            </v-btn>
          </div>
          <div v-if="index+1 == 1">
            <st-first-step
              :data="data"
              @next="nextStep(index+1, $event)"
              @cancel="$emit('input')"
            />
          </div>
          <div v-if="index+1 == 2">
            <st-second-step
              :data="data"
              @next="nextStep(index+1, $event)"
              @cancel="$emit('input')"
            />
          </div>
        </v-stepper-content>
      </v-stepper-items>
    </template>
  </v-stepper>
    </v-card-text>
</v-card>
</v-dialog>
</template>

<script>
import FirstStep from '@/components/programs/RegisterFirstStep'
import SecondStep from '@/components/programs/RegisterSecondStep'

export default {
  props:{
    value: Boolean,
    data: Object
  },
  data () {
    return{
      faculty:{},
      e1: 1,
      steps:[
        'Datos generales',
        'Seleccionar Coordinador',
      ],
    }
  },
  components:{
    'st-first-step': FirstStep,
    'st-second-step': SecondStep,
  },
  mounted(){
  },
  methods:{
        goBack(n){
          this.e1 = n - 1;
        },
        nextStep (n,data) {
          this.faculty[`data${n}`] = data
          if (n === this.steps.length) {
            let { data1, data2 } = this.faculty
            let faculty = { ...data1, ...data2 }

            let type = {tipo:'Programa'}
            let upFaculty = {...data1,...type, ...data2}


            if (!this.data){
              let post ={
                'data':{
                  'programa':faculty
                }
              }
              this.register(post)
            }else{
              let post={
                'programa':upFaculty
              }
              this.update(post)
            }
          } else {
            this.e1 = n + 1
          }
        },
        async register(data){
          try{

            let idFacultad = this.$store.state.role.idUnit;
            let dt={idFacultad: idFacultad, ...data.data}

            let response = await this.$api.addUnitProgram(dt)
            this.$emit('refreshData',{ response: response})
          } catch(e){
            this.$store.commit('setError', e)
          }
        },
        async update(data){
          try{
            let idFacultad= this.$store.state.role.idUnit;

            data.programa.idFacultad = idFacultad
            let response = await this.$api.updateUnit(this.$route.params.id,data)
            this.$emit('refresh',{ response: response})
          }catch (e){
            this.$store.commit('setError', e)
          }
        }

  }
}
</script>
<style scoped lang="scss">
/* scope for encapsulate css */
.v-card__text{
  padding:0 !important
}
</style>
